//************************************************************************************
//**  
//**  File name:     E:\PIC\AVR\1_AVR_my\Attiny26 220v\Forum220v\FORum\U3F_kazus\220v_int_3.c
//**  Generated by:  Flowcode v4.3.9.65
//**  Date:          Tuesday, August 06, 2013 19:26:51
//**  Licence:       Free version
//**  
//**        ***For users exUSSR ***
//**  
//**  
//**     NOT FOR COMMERCIAL USE
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_AVR

//Defines for microcontroller
#define MX_AVR
#define MX_TINY
#define MX_EE
#define MX_EE_SIZE 128
#define MX_USI
#define MX_SPI
#define MX_SPI_B
#define MX_SPI_SDI 0
#define MX_SPI_SDO 1
#define MX_SPI_SCK 2
#define MX_MI2C
#define MX_I2C_B
#define MX_I2C_SDA 0
#define MX_I2C_SCL 2
#define MX_PWM
#define MX_PWM_PORT PORTB
#define MX_PWM_CNT 2
#define MX_PWM_TRIS1 DDRB
#define MX_PWM_1 1
#define MX_PWM_TRIS2 DDRB
#define MX_PWM_2 3
#define MX_PWMTYPE 2

//Functions
#define F_CPU 8000000UL
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <avr\io.h>
#include <avr\interrupt.h>
#include <avr\eeprom.h>
#include <avr\wdt.h>
#include <MX_util\delay.h>
#include <MX_util\bit_cmds.h>

//Configuration data
#pragma DATA 0x0, 0xdf
#pragma DATA 0x1, 0xff

//Internal functions
#include "C:\Program Files\Matrix Multimedia\Flowcode AVR V4\FCD\internals.h"

//Macro function declarations
void FCM_Nomer_seg();


//Variable declarations
volatile char FCV_SEG3;
volatile short FCV_U;
volatile char FCV_SHIFT_SEG;
volatile short FCV_U_ADC;
volatile char FCV_FLAG1;
volatile char FCV_FLAG2;
volatile short FCV_UIN;
volatile char FCV_COD_[14];
volatile char FCV_N1;
volatile char FCV_N2;
volatile short FCV_UIN1;
volatile short FCV_N;
volatile short FCV_UIN2;
volatile short FCV_U_ADC1;
volatile char FCV_FLAG;
volatile short FCV_U_ADC2;
volatile short FCV_SEC;
volatile char FCV_SEG1;
volatile char FCV_ABC;
volatile char FCV_SEG2;


//Defines:

/**** Macro Substitutions ****
7 = Which ADC Channel
20 = Acquisition time
2 = Conversion Speed
0 = VRef+ Option
500 = VRef Voltage x 0.01V
******************************/




//ADC(0): //Macro function declarations

static void FCD_ADC0_SampleADC();
static char FCD_ADC0_ReadAsByte();
static short FCD_ADC0_ReadAsInt();
static float FCD_ADC0_ReadAsVoltage();
static void FCD_ADC0_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE);
static short FCD_ADC0_My_ReadAsInt();
//Defines:

/**** Macro Substitutions ****
8 = Which ADC Channel
20 = Acquisition time
2 = Conversion Speed
0 = VRef+ Option
500 = VRef Voltage x 0.01V
******************************/




//ADC(1): //Macro function declarations

static void FCD_ADC1_SampleADC();
static char FCD_ADC1_ReadAsByte();
static short FCD_ADC1_ReadAsInt();
static float FCD_ADC1_ReadAsVoltage();
static void FCD_ADC1_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE);
//Defines:

/**** Macro Substitutions ****
9 = Which ADC Channel
20 = Acquisition time
2 = Conversion Speed
0 = VRef+ Option
500 = VRef Voltage x 0.01V
******************************/




//ADC(2): //Macro function declarations

static void FCD_ADC2_SampleADC();
static char FCD_ADC2_ReadAsByte();
static short FCD_ADC2_ReadAsInt();
static float FCD_ADC2_ReadAsVoltage();
static void FCD_ADC2_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE);

//Supplementary defines
volatile unsigned long Usum;
volatile unsigned long Usum1;
volatile unsigned long Usum2;



//ADC(0): //Macro implementations


static void FCD_ADC0_SampleADC()
{
	
		#define MX_ADC_CHANNEL		7
		#define MX_ADC_SAMP_TIME 	20
		#define MX_ADC_CONV_SP		2
		#define MX_ADC_VREF_OPT		0

		char ddx, mask = 7;
		volatile char cnt;

		if (7 > 2) mask++;
		if(7 < 7)
		{
			ddx = DDRA;
			DDRA &= ~(1 << mask);
		}else{
			mask -=4;
			ddx = DDRB;
			DDRB &= ~(1 << mask);
		}
		ADCSR = (1 << ADEN) | MX_ADC_CONV_SP;
		ADMUX = (MX_ADC_VREF_OPT << REFS0) | (1 << ADLAR) | MX_ADC_CHANNEL;

		//wait the acquisition time
		cnt = 0;
		while (cnt < MX_ADC_SAMP_TIME) cnt++;

		ADCSR |= (1 << ADSC);
		while(ADCSR & (1 << ADSC));

		if (7 < 7) DDRA = ddx;
		else DDRB = ddx;

		#undef MX_ADC_CHANNEL
		#undef MX_ADC_SAMP_TIME
		#undef MX_ADC_CONV_SP
		#undef MX_ADC_VREF_OPT

}

static char FCD_ADC0_ReadAsByte()
{
	
		FCD_ADC0_SampleADC();

		return ADCH;

}

static short FCD_ADC0_ReadAsInt()
{
	
		int iRetVal;

		FCD_ADC0_SampleADC();

		iRetVal = (ADCL >> 6);
		iRetVal |= (ADCH << 2);
		return (iRetVal);

}

static float FCD_ADC0_ReadAsVoltage()
{
	

		int iSample;
		float fSample, fVoltage, fVperDiv;

		#define MX_ADC_VREF_V		500

		iSample = FCD_ADC0_ReadAsInt();											//Read as 10-bit Integer

		fVoltage = iSample * (float)MX_ADC_VREF_V / 102300.0;			//Find voltage by multiplying sample by resolution

		#undef MX_ADC_VREF_V
		return (fVoltage);

}

static void FCD_ADC0_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE)
{
	
		float fVoltage;

		fVoltage = FCD_ADC0_ReadAsVoltage();
		FCI_FLOAT_TO_STRING(fVoltage, 2, FCR_RETVAL, FCR_RETVAL_SIZE);	//Convert to String

}

static short FCD_ADC0_My_ReadAsInt()
{
	
	int iRetVal;
	while(ADCSR & (1 << ADSC));

		iRetVal = (ADCL >> 6);
		iRetVal |= (ADCH << 2);

	ADCSR |= (1 << ADSC);  
	//while(ADCSR & (1 << ADSC));

	//	iRetVal = (ADCL >> 6);
	//	iRetVal |= (ADCH << 2);
		return (iRetVal);


}



//ADC(1): //Macro implementations


static void FCD_ADC1_SampleADC()
{
	
		#define MX_ADC_CHANNEL		8
		#define MX_ADC_SAMP_TIME 	20
		#define MX_ADC_CONV_SP		2
		#define MX_ADC_VREF_OPT		0

		char ddx, mask = 8;
		volatile char cnt;

		if (8 > 2) mask++;
		if(8 < 7)
		{
			ddx = DDRA;
			DDRA &= ~(1 << mask);
		}else{
			mask -=4;
			ddx = DDRB;
			DDRB &= ~(1 << mask);
		}
		ADCSR = (1 << ADEN) | MX_ADC_CONV_SP;
		ADMUX = (MX_ADC_VREF_OPT << REFS0) | (1 << ADLAR) | MX_ADC_CHANNEL;

		//wait the acquisition time
		cnt = 0;
		while (cnt < MX_ADC_SAMP_TIME) cnt++;

		ADCSR |= (1 << ADSC);
		while(ADCSR & (1 << ADSC));

		if (8 < 7) DDRA = ddx;
		else DDRB = ddx;

		#undef MX_ADC_CHANNEL
		#undef MX_ADC_SAMP_TIME
		#undef MX_ADC_CONV_SP
		#undef MX_ADC_VREF_OPT

}

static char FCD_ADC1_ReadAsByte()
{
	
		FCD_ADC1_SampleADC();

		return ADCH;

}

static short FCD_ADC1_ReadAsInt()
{
	
		int iRetVal;

		FCD_ADC1_SampleADC();

		iRetVal = (ADCL >> 6);
		iRetVal |= (ADCH << 2);
		return (iRetVal);

}

static float FCD_ADC1_ReadAsVoltage()
{
	

		int iSample;
		float fSample, fVoltage, fVperDiv;

		#define MX_ADC_VREF_V		500

		iSample = FCD_ADC1_ReadAsInt();											//Read as 10-bit Integer

		fVoltage = iSample * (float)MX_ADC_VREF_V / 102300.0;			//Find voltage by multiplying sample by resolution

		#undef MX_ADC_VREF_V
		return (fVoltage);

}

static void FCD_ADC1_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE)
{
	
		float fVoltage;

		fVoltage = FCD_ADC1_ReadAsVoltage();
		FCI_FLOAT_TO_STRING(fVoltage, 2, FCR_RETVAL, FCR_RETVAL_SIZE);	//Convert to String

}



//ADC(2): //Macro implementations


static void FCD_ADC2_SampleADC()
{
	
		#define MX_ADC_CHANNEL		9
		#define MX_ADC_SAMP_TIME 	20
		#define MX_ADC_CONV_SP		2
		#define MX_ADC_VREF_OPT		0

		char ddx, mask = 9;
		volatile char cnt;

		if (9 > 2) mask++;
		if(9 < 7)
		{
			ddx = DDRA;
			DDRA &= ~(1 << mask);
		}else{
			mask -=4;
			ddx = DDRB;
			DDRB &= ~(1 << mask);
		}
		ADCSR = (1 << ADEN) | MX_ADC_CONV_SP;
		ADMUX = (MX_ADC_VREF_OPT << REFS0) | (1 << ADLAR) | MX_ADC_CHANNEL;

		//wait the acquisition time
		cnt = 0;
		while (cnt < MX_ADC_SAMP_TIME) cnt++;

		ADCSR |= (1 << ADSC);
		while(ADCSR & (1 << ADSC));

		if (9 < 7) DDRA = ddx;
		else DDRB = ddx;

		#undef MX_ADC_CHANNEL
		#undef MX_ADC_SAMP_TIME
		#undef MX_ADC_CONV_SP
		#undef MX_ADC_VREF_OPT

}

static char FCD_ADC2_ReadAsByte()
{
	
		FCD_ADC2_SampleADC();

		return ADCH;

}

static short FCD_ADC2_ReadAsInt()
{
	
		int iRetVal;

		FCD_ADC2_SampleADC();

		iRetVal = (ADCL >> 6);
		iRetVal |= (ADCH << 2);
		return (iRetVal);

}

static float FCD_ADC2_ReadAsVoltage()
{
	

		int iSample;
		float fSample, fVoltage, fVperDiv;

		#define MX_ADC_VREF_V		500

		iSample = FCD_ADC2_ReadAsInt();											//Read as 10-bit Integer

		fVoltage = iSample * (float)MX_ADC_VREF_V / 102300.0;			//Find voltage by multiplying sample by resolution

		#undef MX_ADC_VREF_V
		return (fVoltage);

}

static void FCD_ADC2_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE)
{
	
		float fVoltage;

		fVoltage = FCD_ADC2_ReadAsVoltage();
		FCI_FLOAT_TO_STRING(fVoltage, 2, FCR_RETVAL, FCR_RETVAL_SIZE);	//Convert to String

}

//Macro implementations

void FCM_Nomer_seg()
{
	
	//C Code
	//C Code:
	TCNT0=150;


	//Decision
	//Decision: SEC>600?
	if (FCV_SEC>600)
	{
		//Calculation
		//Calculation:
		//  SEC = 0
		FCV_SEC = 0;
		

		//Calculation
		//Calculation:
		//  ABC = ABC+1
		FCV_ABC = FCV_ABC+1;
		

		//Decision
		//Decision: ABC>12?
		if (FCV_ABC>12)
		{
			//Calculation
			//Calculation:
			//  ABC = 10
			FCV_ABC = 10;
			

		}


		//Switch
		//Switch: ABC?
		switch (FCV_ABC)
		{
			case 10:
			{
				//
				//Calculation:
				//  seg1 = Uin / 100
				//  seg2 = (Uin/10)%10
				//  seg3 = Uin%10
				FCV_SEG1 = FCV_UIN / 100;
				FCV_SEG2 = (FCV_UIN/10)%10;
				FCV_SEG3 = FCV_UIN%10;
				

				break;
			}

			case 11:
			{
				//
				//Calculation:
				//  seg1 = Uin1 / 100
				//  seg2 = (Uin1/10)%10
				//  seg3 = Uin1%10
				FCV_SEG1 = FCV_UIN1 / 100;
				FCV_SEG2 = (FCV_UIN1/10)%10;
				FCV_SEG3 = FCV_UIN1%10;
				

				break;
			}

			case 12:
			{
				//
				//Calculation:
				//  seg1 = Uin2 / 100
				//  seg2 = (Uin2/10)%10
				//  seg3 = Uin2%10
				FCV_SEG1 = FCV_UIN2 / 100;
				FCV_SEG2 = (FCV_UIN2/10)%10;
				FCV_SEG3 = FCV_UIN2%10;
				

				break;
			}

		}


	} else {
		//Calculation
		//Calculation:
		//  SEC = SEC+1
		FCV_SEC = FCV_SEC+1;
		

	}


	//
	//Calculation:
	//  shift_seg = shift_seg>>1
	FCV_SHIFT_SEG = FCV_SHIFT_SEG>>1;
	

	//
	//Output: 0 -> PORT B
	DDRB = DDRB | 0x0f;
	PORTB = (PORTB & 0xf0) | 0;


	//  
	//Output: shift_seg -> PORT B
	DDRB = DDRB | 0x0f;
	PORTB = (PORTB & 0xf0) | FCV_SHIFT_SEG;


	//
	//Switch: shift_seg?
	switch (FCV_SHIFT_SEG)
	{
		case 1:
		{
			//
			//Output: COD_[ABC] -> PORT A
			DDRA = 0xFF;
			PORTA = FCV_COD_[FCV_ABC];


			//
			//Calculation:
			//  shift_seg = 16
			FCV_SHIFT_SEG = 16;
			

			break;
		}

		case 2:
		{
			//
			//Output: COD_[seg1] -> PORT A
			DDRA = 0xFF;
			PORTA = FCV_COD_[FCV_SEG1];


			break;
		}

		case 4:
		{
			//
			//Output: COD_[seg2] -> PORT A
			DDRA = 0xFF;
			PORTA = FCV_COD_[FCV_SEG2];


			break;
		}

		case 8:
		{
			//
			//Output: COD_[seg3] -> PORT A
			DDRA = 0xFF;
			PORTA = FCV_COD_[FCV_SEG3];


			break;
		}

	}


}

//Supplementary implementations


int main()
{
	
	//Initialisation
	MCUSR=0x00;
	wdt_disable();


	//Interrupt initialisation code
	
	//
	//Calculation:
	//  COD_[0] = 192
	//  COD_[1] = 249
	//  COD_[2] = 164
	//  COD_[3] = 176
	//  COD_[4] = 153
	//  COD_[5] = 146
	//  COD_[6] = 130
	//  COD_[7] = 248
	//  COD_[8] = 128
	//  COD_[9] = 144
	//  COD_[10] = 136
	//  COD_[11] = 131
	//  COD_[12] = 198
	//  COD_[13] = 227
	FCV_COD_[0] = 192;
	FCV_COD_[1] = 249;
	FCV_COD_[2] = 164;
	FCV_COD_[3] = 176;
	FCV_COD_[4] = 153;
	FCV_COD_[5] = 146;
	FCV_COD_[6] = 130;
	FCV_COD_[7] = 248;
	FCV_COD_[8] = 128;
	FCV_COD_[9] = 144;
	FCV_COD_[10] = 136;
	FCV_COD_[11] = 131;
	FCV_COD_[12] = 198;
	FCV_COD_[13] = 227;
	

	//
	//Calculation:
	//  shift_seg = 16
	FCV_SHIFT_SEG = 16;
	

	//Calculation
	//Calculation:
	//  SEC = 0
	FCV_SEC = 0;
	

	//Calculation
	//Calculation:
	//  ABC = 13
	FCV_ABC = 13;
	

	//Calculation
	//Calculation:
	//  Flag = 1
	//  Flag1 = 1
	//  Flag2 = 1
	FCV_FLAG = 1;
	FCV_FLAG1 = 1;
	FCV_FLAG2 = 1;
	

	//
	//Interrupt: Enable TMR0
	TCCR0 &= 0xf8;
	TCCR0 |= 0x04;
	sei();
	TIMSK |= (1 << TOIE0);


	//Comment:
	// 6  


	//C Code
	//C Code:
	DDRB = DDRB | 0x80;



	//
	//Loop: While 1
	while (1)
	{
		// 
		//Call Component Macro: U_ADC=ADC(0)::ReadAsInt
		FCV_U_ADC = FCD_ADC0_ReadAsInt();


		//Calculation
		//Calculation:
		//  N = N+1
		FCV_N = FCV_N+1;
		

		//Call Component Macro
		//Call Component Macro: U_ADC1=ADC(1)::ReadAsInt
		FCV_U_ADC1 = FCD_ADC1_ReadAsInt();


		//Calculation
		//Calculation:
		//  N1 = N1+1
		FCV_N1 = FCV_N1+1;
		

		//Call Component Macro
		//Call Component Macro: U_ADC2=ADC(2)::ReadAsInt
		FCV_U_ADC2 = FCD_ADC2_ReadAsInt();


		//Calculation
		//Calculation:
		//  N2 = N2+1
		FCV_N2 = FCV_N2+1;
		

		//C Code
		//C Code:
		//Usum=Usum+FCV_U_ADC;
		Usum+=FCV_U_ADC;


		//C Code
		//C Code:
		//Usum=Usum+FCV_U_ADC;
		Usum1+=FCV_U_ADC1;


		//C Code
		//C Code:
		//Usum=Usum+FCV_U_ADC;
		Usum2+=FCV_U_ADC2;


		//
		//Decision: U_ADC<40 AND Flag=1 AND N>90?
		if (FCV_U_ADC<40 & FCV_FLAG==1 & FCV_N>90)
		{
			//Comment:
			// 


			//C Code
			//C Code:
			PORTB = (PORTB & 0x7f) | 0x80;



			//Calculation
			//Calculation:
			//  Flag = 0
			FCV_FLAG = 0;
			

			//C Code
			//C Code:
			//FCV_UIN=(Usum/FCV_N)/1.6;
			FCV_UIN=(Usum/FCV_N);


			//C Code
			//C Code:
			Usum=0;


			//Calculation
			//Calculation:
			//  N = 0
			FCV_N = 0;
			

			//C Code
			//C Code:
			PORTB = PORTB & 0x7f;



		} else {
			//Decision
			//Decision: U_ADC>40 AND Flag=0?
			if (FCV_U_ADC>40 & FCV_FLAG==0)
			{
				//Comment:
				// 


				//Calculation
				//Calculation:
				//  Flag = 1
				FCV_FLAG = 1;
				

			}


		}


		//
		//Decision: U_ADC1<40 AND Flag1=1?
		if (FCV_U_ADC1<40 & FCV_FLAG1==1)
		{
			//C Code
			//C Code:
			FCV_UIN1=Usum1/FCV_N1;


			//Calculation
			//Calculation:
			//  Flag1 = 0
			FCV_FLAG1 = 0;
			

			//C Code
			//C Code:
			Usum1=0;


			//Calculation
			//Calculation:
			//  N1 = 0
			FCV_N1 = 0;
			

		} else {
			//Decision
			//Decision: U_ADC1>40 AND Flag1=0?
			if (FCV_U_ADC1>40 & FCV_FLAG1==0)
			{
				//Calculation
				//Calculation:
				//  Flag1 = 1
				FCV_FLAG1 = 1;
				

			}


		}


		//
		//Decision: U_ADC2<40 AND Flag2=1?
		if (FCV_U_ADC2<40 & FCV_FLAG2==1)
		{
			//C Code
			//C Code:
			FCV_UIN2=Usum2/FCV_N2;


			//Calculation
			//Calculation:
			//  Flag2 = 0
			FCV_FLAG2 = 0;
			

			//C Code
			//C Code:
			Usum2=0;


			//Calculation
			//Calculation:
			//  N2 = 0
			FCV_N2 = 0;
			

		} else {
			//Decision
			//Decision: U_ADC2>40 AND Flag2=0?
			if (FCV_U_ADC2>40 & FCV_FLAG2==0)
			{
				//Calculation
				//Calculation:
				//  Flag2 = 1
				FCV_FLAG2 = 1;
				

			}


		}


	}


	mainendloop: goto mainendloop;
}

	//Handler code for [TMR0]
	#ifndef MX_TIMER0OVF_HANDLER
	#define MX_TIMER0OVF_HANDLER
	ISR(TIMER0_OVF0_vect)
	{
		FCM_Nomer_seg();
	}
	#else
	#warning The <TIMER0 OVF> interrupt has previously been enabled, so the macro <Nomer_seg> may never get called.
	#endif




